---
title: XRWebGLLayer.framebuffer
slug: Web/API/XRWebGLLayer/framebuffer
tags:
  - API
  - AR
  - Buffer
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayer
  - augmented
  - framebuffer
---
<p>{{securecontext_header}}{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRWebGLLayer")}} property <code><strong>framebuffer</strong></code> is an opaque {{domxref("WebGLFramebuffer")}} which is used to buffer the rendered image if the <a href="/en-US/docs/Web/API/WebXR_Device_API/Fundamentals#The_WebXR_compositor">XR compositor</a> is being used. Otherwise, this property's value is <code>null</code>.</span> The opaque framebuffer is functionally nearly the same as a standard WebGL framebuffer, except for the differences covered in the section {{anch("How opaque framebuffers are special")}} below.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>framebuffer</em> = <em>xrWebGLLayer</em>.framebuffer;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("WebGLFramebuffer")}} object representing the framebuffer into which the 3D scene is being rendered, or <code>null</code> if the <a href="en-US/docs/Web/API/WebXR_Device_API/Fundamentals#The_WebXR_compositor">XR compositor</a> is disabled for the session.</p>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="How_opaque_framebuffers_are_special">How opaque framebuffers are special</h3>

<p>The framebuffer represented by the <code>framebuffer</code> property is opaque. As such, its behavior is different in several ways from a standard WebGL context. These differences cause the opaque framebuffer to behave more like the default WebGL framebuffer:</p>

<ul>
 <li>Opaque framebuffers <em>may</em> support <a href="/en-US/docs/Web/API/XRWebGLLayer/antialias">anti-aliasing</a>, even under WebGL 1.0, which don't normally do so.</li>
 <li>Opaque framebuffers' attachments (buffers and the like) can't be inspected or changed. Calling functions such as {{domxref("WebGLRenderingContext.framebufferTexture2D", "framebufferTexture2D()")}}, {{domxref("WebGLRenderingContext.framebufferRenderbuffer", "framebufferRenderbuffer()")}}, {{domxref("WebGLRenderingContext.deleteFramebuffer", "deleteFramebuffer()")}}, or {{domxref("WebGLRenderingContext.getFramebufferAttachmentParameter", "getFramebufferAttachmentParameter()")}} on an opaque framebuffer results in the WebGL error <code>INVALID_OPERATION</code> (0x0502).</li>
 <li>Opaque framebuffers are considered incomplete and are not available for rendering other than while executing the {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} callback. Attempting to clear, draw to, or read from the framebuffer results in a WebGL <code>INVALID_FRAMEBUFFER_OPERATION</code> error (0x0506). Calling {{domxref("WebGLRenderingContext.checkFramebufferStatus", "checkFramebufferStatus()")}} on the WebGL context from outside the animation frame callback causes the WebGL <code>FRAMEBUFFER_UNSUPPORTED</code> error (0x8CDD) to be reported.</li>
 <li>Opaque framebuffers initialized with the {{domxref("WebXRLayerInit.depth", "depth")}} property set to <code>false</code> will not have a depth buffer and will rely on the coordinates alone to determine distance.</li>
 <li>Opaque framebuffers initialized without specifying a {{domxref("WebXRLayerInit.stencil", "stencil")}} will not have a stencil buffer.</li>
 <li>Opaque framebuffers will not have an alpha channel available unless the {{domxref("WebGLLayerInit.alpha", "alpha")}} property is <code>true</code> when creating the layer.</li>
 <li>The XR compositor assumes that opaque framebuffers use colors with premultiplied allpha, regardless of whether or not the WebGL context's {{domxref("WebGLContextAttributes.premultipliedAlpha", "premultipliedAlpha")}} context attribute is set.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> The <code>depth</code> and <code>stencil</code> properties are not required to be supported in order for a browser to be construed as having full WebGL support.</p>
</div>

<h3 id="The_default_configuration_of_a_new_framebuffer">The default configuration of a new framebuffer</h3>

<p>Upon creating a new {{domxref("XRWebGLLayer")}}, its new framebuffer is initialized just like the default framebuffer for any WebGL interface:</p>

<ul>
 <li>The color buffer is configured with its clear value set to the color (0, 0, 0, 0) (meaning transparent black).</li>
 <li>The depth buffer's clear value is the number 1.0.</li>
 <li>The stencil buffer is filled with 0.</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>This example gets the <code>XRWebGLLayer</code> for a session and then passes its framebuffer into the WebGL context's {{domxref("WebGLRenderingContext.bindFramebuffer", "bindFramebuffer()")}} function.</p>

<pre class="brush: js notranslate">let glLayer = xrSession.renderState.baselayer;
gl.bindFramebuffer(gl.FRAMEBUFFER, glLayer.framebuffer);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayer-framebuffer','XRWebGLLayer.framebuffer')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayer.framebuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li>{{domxref("WebGLLayerInit")}}</li>
 <li>{{domxref("WebGLContextAttributes")}}</li>
</ul>
